Index: squid/src/ipcache.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/ipcache.c,v
retrieving revision 1.4.6.14
retrieving revision 1.4.6.15
diff -u -r1.4.6.14 -r1.4.6.15
--- squid/src/ipcache.c	1 Jul 2007 08:34:28 -0000	1.4.6.14
+++ squid/src/ipcache.c	2 Jul 2007 07:37:00 -0000	1.4.6.15
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ipcache.c,v 1.4.6.14 2007/07/01 08:34:28 amosjeffries Exp $
+ * $Id: ipcache.c,v 1.4.6.15 2007/07/02 07:37:00 amosjeffries Exp $
  *
  * DEBUG: section 14    IP Cache
  * AUTHOR: Harvest Derived
@@ -112,7 +112,7 @@
 static void
 ipcacheRelease(ipcache_entry * i)
 {
-    debug(14, 3) ("ipcacheRelease: Releasing entry %x for '%s'\n", i, (const char *) i->hash.key);
+    debug(14, 3) ("ipcacheRelease: Releasing entry for '%s'\n", (const char *) i->hash.key);
     hash_remove_link(ip_table, (hash_link *) i);
     dlinkDelete(&i->lru, &lru_list);
     ipcacheFreeEntry(i);
@@ -200,16 +200,7 @@
     if (NULL != e) {
 	/* avoid colission */
 	ipcache_entry *q = (ipcache_entry *) e;
-	if (i != q)
-	    ipcacheRelease(q);
-	else {
-/*
-	    dlinkDelete(&i->lru, &lru_list);
-	    dlinkAdd(i, &i->lru, &lru_list);
-*/
-	    i->lastref = squid_curtime;
-	    return;
-	}
+	ipcacheRelease(q);
     }
     hash_join(ip_table, &i->hash);
     dlinkAdd(i, &i->lru, &lru_list);
@@ -294,7 +285,7 @@
     if (ipcount <= 0) {
 	debug(14, 1) ("ipcacheParse: No addresses in response to '%s'\n", name);
     } else {
-	i->addrs.in_addrs = xcalloc(ipcount, sizeof(struct sockaddr_storage));
+	i->addrs.in_addrs = xcalloc(ipcount, sizeof(struct in_addr));
 	i->addrs.bad_mask = xcalloc(ipcount, sizeof(unsigned char));
 	for (j = 0, k = 0; k < ipcount; k++) {
 	    if (safe_inet_addr(A[k], &i->addrs.in_addrs[j]))
@@ -320,12 +311,12 @@
     int na = 0;
     int ttl = 0;
     const char *name = (const char *) i->hash.key;
-
-	debug(14, 3) ("ipcacheParse: ipcache_entry %x\n", i);
-    if (!i->addrs.count) {
-	i->expires = squid_curtime + Config.negativeDnsTtl;
-	i->flags.negcached = 1;
-    }
+    i->expires = squid_curtime + Config.negativeDnsTtl;
+    i->flags.negcached = 1;
+    safe_free(i->addrs.in_addrs);
+    safe_free(i->addrs.bad_mask);
+    safe_free(i->error_message);
+    i->addrs.count = 0;
     if (nr < 0) {
 	debug(14, 3) ("ipcacheParse: Lookup failed '%s' for '%s'\n",
 	    error_message, (const char *) i->hash.key);
@@ -333,83 +324,47 @@
 	return i;
     }
     if (nr == 0) {
-	if (!i->addrs.count) {
-	    debug(14, 3) ("ipcacheParse: No DNS records in response to '%s'\n", name);
-/*
-	    i->error_message = xstrdup("No DNS records");
-*/
-	}
+	debug(14, 3) ("ipcacheParse: No DNS records in response to '%s'\n", name);
+	i->error_message = xstrdup("No DNS records");
 	return i;
     }
     assert(answers);
     for (k = 0; k < nr; k++) {
-	if ((answers[k].type != RFC1035_TYPE_A) && (answers[k].type != RFC1035_TYPE_AAAA))
+	if (answers[k].type != RFC1035_TYPE_A)
 	    continue;
 	if (answers[k].class != RFC1035_CLASS_IN)
 	    continue;
-	if ((answers[k].rdlength != 4) && (answers[k].rdlength != 16)) {
+	if (answers[k].rdlength != 4) {
 	    debug(14, 1) ("ipcacheParse: Invalid IP address in response to '%s'\n", name);
 	    continue;
 	}
 	na++;
     }
     if (na == 0) {
-	if (!i->addrs.count) {
-	    debug(14, 1) ("ipcacheParse: No Address records in response to '%s'\n", name);
-	    i->error_message = xstrdup("No Address records");
-	}
+	debug(14, 1) ("ipcacheParse: No Address records in response to '%s'\n", name);
+	i->error_message = xstrdup("No Address records");
 	return i;
     }
     i->flags.negcached = 0;
-    if (i->addrs.count > 0) {
-        int total_cnt = i->addrs.count + na;
-	if (total_cnt > 255) total_cnt == 255;
-	i->addrs.in_addrs = xrealloc(i->addrs.in_addrs, total_cnt*sizeof(struct sockaddr_storage));
-	i->addrs.bad_mask = xrealloc(i->addrs.bad_mask, total_cnt*sizeof(unsigned char));
-    }
-    else {
-	i->addrs.in_addrs = xcalloc(na, sizeof(struct sockaddr_storage));
-	i->addrs.bad_mask = xcalloc(na, sizeof(unsigned char));
-    }
+    i->addrs.in_addrs = xcalloc(na, sizeof(struct in_addr));
+    i->addrs.bad_mask = xcalloc(na, sizeof(unsigned char));
     for (j = 0, k = 0; k < nr; k++) {
 	if (answers[k].class != RFC1035_CLASS_IN)
 	    continue;
 	if (answers[k].type == RFC1035_TYPE_A) {
-	    struct sockaddr_in *this_answer = (struct sockaddr_in *)&i->addrs.in_addrs[j+i->addrs.count];
 	    if (answers[k].rdlength != 4)
 		continue;
-	    this_answer->sin_family = AF_INET;
-#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
-	    this_answer->sin_len = sizeof(struct sockaddr_in);
-#endif
-	    xmemcpy(&this_answer->sin_addr, answers[k].rdata, 4);
+	    xmemcpy(&i->addrs.in_addrs[j++], answers[k].rdata, 4);
 	    debug(14, 3) ("ipcacheParse: #%d %s\n",
-		j,
-		sockaddr_ntoa(&i->addrs.in_addrs[j+i->addrs.count]));
-	    j++;
-	} else if (answers[k].type == RFC1035_TYPE_AAAA) {
-	    struct sockaddr_in6 *this_answer = (struct sockaddr_in6 *)&i->addrs.in_addrs[j+i->addrs.count];
-	    if (answers[k].rdlength != 16)
-		continue;
-	    this_answer->sin6_family = AF_INET6;
-#if defined(_SQUID_FREEBSD_) || defined(_SQUID_NETBSD_) || defined(_SQUID_OPENBSD_)
-	    this_answer->sin6_len = sizeof(struct sockaddr_in6);
-#endif
-	    xmemcpy(&this_answer->sin6_addr, answers[k].rdata, 16);
-	    debug(14, 3) ("ipcacheParse: #%d %s\n",
-		j,
-		sockaddr_ntoa(&i->addrs.in_addrs[j+i->addrs.count]));
-	    j++;
-	    i->addrs.cur = i->addrs.count;
-	    if (i->addrs.cur)
-		i->addrs.cur--;
+		j - 1,
+		inet_ntoa(i->addrs.in_addrs[j - 1]));
 	} else if (answers[k].type != RFC1035_TYPE_CNAME)
 	    continue;
 	if (ttl == 0 || ttl > answers[k].ttl)
 	    ttl = answers[k].ttl;
     }
-    if ((i->addrs.count + na) < 256)
-	i->addrs.count += (unsigned char) na;
+    if (na < 256)
+	i->addrs.count = (unsigned char) na;
     else
 	i->addrs.count = 255;
     if (ttl == 0 || ttl > Config.positiveDnsTtl)
@@ -429,22 +384,10 @@
 ipcacheHandleReply(void *data, rfc1035_rr * answers, int na, const char *error_message)
 #endif
 {
-    int pairs = 0;
     generic_cbdata *c = data;
     ipcache_entry *i = c->data;
-
-#if !USE_DNSSERVERS
-    if (na > 5000) {
-	na = na - 10000;
-	pairs = 1;
-    }
-    if (!pairs) {
-#endif
-	cbdataFree(c);
-	c = NULL;
-#if !USE_DNSSERVERS
-    }
-#endif
+    cbdataFree(c);
+    c = NULL;
     IpcacheStats.replies++;
     statHistCount(&statCounter.dns.svc_time,
 	tvSubMsec(i->request_time, current_time));
@@ -453,15 +396,8 @@
 #else
     ipcacheParse(i, answers, na, error_message);
 #endif
-#if !USE_DNSSERVERS
-    if (!pairs)
-    {
-#endif
     ipcacheAddEntry(i);
     ipcacheCallback(i);
-#if !USE_DNSSERVERS
-    }
-#endif
 }
 
 void
@@ -514,8 +450,6 @@
     i->request_time = current_time;
     c = cbdataAlloc(generic_cbdata);
     c->data = i;
-    ipcacheAddEntry(i);
-    debug(14, 5) ("ipcache_nbgethostbyname: create ipcacheEntry %x'\n", (void *)i);
 #if USE_DNSSERVERS
     dnsSubmit(hashKeyStr(&i->hash), ipcacheHandleReply, c);
 #else
@@ -540,7 +474,7 @@
 	debug(14, 1) ("Successful DNS name lookup tests...\n");
     }
     memset(&static_addrs, '\0', sizeof(ipcache_addrs));
-    static_addrs.in_addrs = xcalloc(1, sizeof(struct sockaddr_storage));
+    static_addrs.in_addrs = xcalloc(1, sizeof(struct in_addr));
     static_addrs.bad_mask = xcalloc(1, sizeof(unsigned char));
     ipcache_high = (long) (((float) Config.ipcache.size *
 	    (float) Config.ipcache.high) / (float) 100);
@@ -601,7 +535,7 @@
 	(int) i->addrs.count,
 	(int) i->addrs.badcount);
     for (k = 0; k < (int) i->addrs.count; k++) {
-	storeAppendPrintf(sentry, " %15s-%3s", sockaddr_ntoa(&i->addrs.in_addrs[k]),
+	storeAppendPrintf(sentry, " %15s-%3s", inet_ntoa(i->addrs.in_addrs[k]),
 	    i->addrs.bad_mask[k] ? "BAD" : "OK ");
     }
     storeAppendPrintf(sentry, "\n");
@@ -672,13 +606,13 @@
 ipcache_addrs *
 ipcacheCheckNumeric(const char *name)
 {
-    struct sockaddr_storage ip;
+    struct in_addr ip;
     /* check if it's already a IP address in text form. */
     if (!safe_inet_addr(name, &ip))
 	return NULL;
     static_addrs.count = 1;
     static_addrs.cur = 0;
-    xmemcpy(&static_addrs.in_addrs[0], &ip, sizeof(ip));
+    static_addrs.in_addrs[0].s_addr = ip.s_addr;
     static_addrs.bad_mask[0] = FALSE;
     static_addrs.badcount = 0;
     return &static_addrs;
@@ -730,10 +664,8 @@
 	ia->badcount = 0;
 	ia->cur = 0;
     }
-/*
     debug(14, 3) ("ipcacheCycleAddr: %s now at %s\n", name,
-	sockaddr_ntoa(&ia->in_addrs[ia->cur]));
-*/
+	inet_ntoa(ia->in_addrs[ia->cur]));
 }
 
 /*
@@ -741,7 +673,7 @@
  * advance the current pointer to the next OK address.
  */
 void
-ipcacheMarkBadAddr(const char *name, struct sockaddr *addr)
+ipcacheMarkBadAddr(const char *name, struct in_addr addr)
 {
     ipcache_entry *i;
     ipcache_addrs *ia;
@@ -750,17 +682,7 @@
 	return;
     ia = &i->addrs;
     for (k = 0; k < (int) ia->count; k++) {
-	if (ia->in_addrs->ss_family != addr->sa_family)
-	    continue;
-	if ((ia->in_addrs->ss_family == AF_INET) &&
-	    memcmp(&((struct sockaddr_in *)ia->in_addrs)->sin_addr,
-		&((struct sockaddr_in *)addr)->sin_addr,
-		sizeof(struct in_addr)) )
-	    break;
-	if ((ia->in_addrs->ss_family == AF_INET6) &&
-	    memcmp(&((struct sockaddr_in6 *)ia->in_addrs)->sin6_addr,
-		&((struct sockaddr_in6 *)addr)->sin6_addr,
-		sizeof(struct in6_addr)) )
+	if (ia->in_addrs[k].s_addr == addr.s_addr)
 	    break;
     }
     if (k == (int) ia->count)	/* not found */
@@ -769,13 +691,13 @@
 	ia->bad_mask[k] = TRUE;
 	ia->badcount++;
 	i->expires = XMIN(squid_curtime + XMAX(60, Config.negativeDnsTtl), i->expires);
-	debug(14, 2) ("ipcacheMarkBadAddr: %s [%s]\n", name, sockaddr_ntoa(addr));
+	debug(14, 2) ("ipcacheMarkBadAddr: %s [%s]\n", name, inet_ntoa(addr));
     }
     ipcacheCycleAddr(name, ia);
 }
 
 void
-ipcacheMarkGoodAddr(const char *name, struct sockaddr *addr)
+ipcacheMarkGoodAddr(const char *name, struct in_addr addr)
 {
     ipcache_entry *i;
     ipcache_addrs *ia;
@@ -784,17 +706,7 @@
 	return;
     ia = &i->addrs;
     for (k = 0; k < (int) ia->count; k++) {
-	if (ia->in_addrs->ss_family != addr->sa_family)
-	    continue;
-	if ((ia->in_addrs->ss_family == AF_INET) &&
-	    memcmp(&((struct sockaddr_in *)ia->in_addrs)->sin_addr,
-		&((struct sockaddr_in *)addr)->sin_addr,
-		sizeof(struct in_addr)) )
-	    break;
-	if ((ia->in_addrs->ss_family == AF_INET6) &&
-	    memcmp(&((struct sockaddr_in6 *)ia->in_addrs)->sin6_addr,
-		&((struct sockaddr_in6 *)addr)->sin6_addr,
-		sizeof(struct in6_addr)) )
+	if (ia->in_addrs[k].s_addr == addr.s_addr)
 	    break;
     }
     if (k == (int) ia->count)	/* not found */
@@ -803,7 +715,7 @@
 	return;
     ia->bad_mask[k] = FALSE;
     ia->badcount--;
-    debug(14, 2) ("ipcacheMarkGoodAddr: %s [%s]\n", name, sockaddr_ntoa(addr));
+    debug(14, 2) ("ipcacheMarkGoodAddr: %s [%s]\n", name, inet_ntoa(addr));
 }
 
 static void
@@ -844,7 +756,7 @@
 ipcacheAddEntryFromHosts(const char *name, const char *ipaddr)
 {
     ipcache_entry *i;
-    struct sockaddr_storage ip;
+    struct in_addr ip;
     if (!safe_inet_addr(ipaddr, &ip)) {
 	if (strchr(ipaddr, ':') && strspn(ipaddr, "0123456789abcdefABCDEF:") == strlen(ipaddr)) {
 	    debug(14, 3) ("ipcacheAddEntryFromHosts: Skipping IPv6 address '%s'\n", ipaddr);
@@ -869,9 +781,9 @@
     i->addrs.count = 1;
     i->addrs.cur = 0;
     i->addrs.badcount = 0;
-    i->addrs.in_addrs = xcalloc(1, sizeof(struct sockaddr_storage));
+    i->addrs.in_addrs = xcalloc(1, sizeof(struct in_addr));
     i->addrs.bad_mask = xcalloc(1, sizeof(unsigned char));
-    xmemcpy(&i->addrs.in_addrs[0], &ip, sizeof(ip));
+    i->addrs.in_addrs[0].s_addr = ip.s_addr;
     i->addrs.bad_mask[0] = FALSE;
     i->flags.fromhosts = 1;
     ipcacheAddEntry(i);
Index: squid/src/main.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/main.c,v
retrieving revision 1.5.4.8
retrieving revision 1.5.4.9
diff -u -r1.5.4.8 -r1.5.4.9
--- squid/src/main.c	1 Jul 2007 05:44:23 -0000	1.5.4.8
+++ squid/src/main.c	2 Jul 2007 07:37:00 -0000	1.5.4.9
@@ -1,6 +1,6 @@
 
 /*
- * $Id: main.c,v 1.5.4.8 2007/07/01 05:44:23 amosjeffries Exp $
+ * $Id: main.c,v 1.5.4.9 2007/07/02 07:37:00 amosjeffries Exp $
  *
  * DEBUG: section 1     Startup and Main Loop
  * AUTHOR: Harvest Derived
@@ -663,7 +663,6 @@
 {
     int errcount = 0;
     int loop_delay;
-    struct sockaddr_storage curaddr;
 #ifdef _SQUID_WIN32_
     int WIN32_init_err;
 #endif
@@ -696,15 +695,11 @@
 #endif /* HAVE_MALLOPT */
 
     memset(&local_addr, '\0', sizeof(struct in_addr));
-    memset(&curaddr, '\0', sizeof(curaddr));
-    safe_inet_addr(localhost, &curaddr);
-    local_addr.s_addr = ((struct sockaddr_in *)&curaddr)->sin_addr.s_addr;
+    safe_inet_addr(localhost, &local_addr);
     memset(&any_addr, '\0', sizeof(struct in_addr));
-    safe_inet_addr("0.0.0.0", &curaddr);
-    any_addr.s_addr = ((struct sockaddr_in *)&curaddr)->sin_addr.s_addr;
+    safe_inet_addr("0.0.0.0", &any_addr);
     memset(&no_addr, '\0', sizeof(struct in_addr));
-    safe_inet_addr("255.255.255.255", &curaddr);
-    no_addr.s_addr = ((struct sockaddr_in *)&curaddr)->sin_addr.s_addr;
+    safe_inet_addr("255.255.255.255", &no_addr);
     squid_srandom(time(NULL));
 
     getCurrentTime();
Index: squid/src/multicast.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/multicast.c,v
retrieving revision 1.3.6.5
retrieving revision 1.3.6.6
diff -u -r1.3.6.5 -r1.3.6.6
--- squid/src/multicast.c	1 Jul 2007 05:44:24 -0000	1.3.6.5
+++ squid/src/multicast.c	2 Jul 2007 07:37:00 -0000	1.3.6.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: multicast.c,v 1.3.6.5 2007/07/01 05:44:24 amosjeffries Exp $
+ * $Id: multicast.c,v 1.3.6.6 2007/07/02 07:37:00 amosjeffries Exp $
  *
  * DEBUG: section 7     Multicast
  * AUTHOR: Martin Hamilton
@@ -62,16 +62,14 @@
     }
     for (i = 0; i < (int) ia->count; i++) {
 	debug(7, 10) ("Listening for ICP requests on %s\n",
-	    sockaddr_ntoa((ia->in_addrs + i)));
-	if (ia->in_addrs->ss_family != AF_INET)
-	  continue;
-	mr.imr_multiaddr.s_addr = ((struct sockaddr_in *)(ia->in_addrs + i))->sin_addr.s_addr;
+	    inet_ntoa(*(ia->in_addrs + i)));
+	mr.imr_multiaddr.s_addr = (ia->in_addrs + i)->s_addr;
 	mr.imr_interface.s_addr = INADDR_ANY;
 	x = setsockopt(fd, IPPROTO_IP, IP_ADD_MEMBERSHIP,
 	    (char *) &mr, sizeof(struct ip_mreq));
 	if (x < 0)
 	    debug(7, 1) ("comm_join_mcast_groups: FD %d, [%s]\n",
-		fd, sockaddr_ntoa((ia->in_addrs + i)));
+		fd, inet_ntoa(*(ia->in_addrs + i)));
 	x = setsockopt(fd, IPPROTO_IP, IP_MULTICAST_LOOP, &c, 1);
 	if (x < 0)
 	    debug(7, 1) ("Can't disable multicast loopback: %s\n", xstrerror());
Index: squid/src/neighbors.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/neighbors.c,v
retrieving revision 1.5.4.10
retrieving revision 1.5.4.11
diff -u -r1.5.4.10 -r1.5.4.11
--- squid/src/neighbors.c	1 Jul 2007 08:34:29 -0000	1.5.4.10
+++ squid/src/neighbors.c	2 Jul 2007 07:37:00 -0000	1.5.4.11
@@ -1,6 +1,6 @@
 
 /*
- * $Id: neighbors.c,v 1.5.4.10 2007/07/01 08:34:29 amosjeffries Exp $
+ * $Id: neighbors.c,v 1.5.4.11 2007/07/02 07:37:00 amosjeffries Exp $
  *
  * DEBUG: section 15    Neighbor Routines
  * AUTHOR: Harvest Derived
@@ -53,7 +53,7 @@
 static void peerCountMcastPeersStart(void *data);
 static void peerCountMcastPeersSchedule(peer * p, time_t when);
 static IRCB peerCountHandleIcpReply;
-static void neighborIgnoreNonPeer(const struct sockaddr *, icp_opcode);
+static void neighborIgnoreNonPeer(const struct sockaddr_in *, icp_opcode);
 static OBJH neighborDumpPeers;
 static OBJH neighborDumpNonPeers;
 static void dump_peers(StoreEntry * sentry, peer * peers);
@@ -78,30 +78,17 @@
 
 
 peer *
-whichPeer(const struct sockaddr * from)
+whichPeer(const struct sockaddr_in * from)
 {
     int j;
-    u_short port; 
+    u_short port = ntohs(from->sin_port);
+    struct in_addr ip = from->sin_addr;
     peer *p = NULL;
-    char hbuf[80], sbuf[8];
-    getnameinfo(from, SOCKLEN(from), hbuf, 80, sbuf, 8,
-	NI_NUMERICHOST|NI_NUMERICSERV);
-    debug(15, 3) ("whichPeer: from %s port %s\n", hbuf, sbuf);
+    debug(15, 3) ("whichPeer: from %s port %d\n", inet_ntoa(ip), port);
     for (p = Config.peers; p; p = p->next) {
 	for (j = 0; j < p->n_addresses; j++) {
-	    if (from->sa_family !=  p->addresses[j].ss_family)
-		continue;
-	    switch (from->sa_family) {
-		case AF_INET6:
-		if ( IN6_ARE_ADDR_EQUAL(&((struct sockaddr_in6 *)&p->addresses[j])->sin6_addr, &((struct sockaddr_in6 *)from)->sin6_addr) &&
-		    (p->icp.port == ntohs(((struct sockaddr_in6 *)from)->sin6_port)))
-		    return p;
-		break;
-		case AF_INET:
-		if ( (((struct sockaddr_in *)&p->addresses[j])->sin_addr.s_addr == ((struct sockaddr_in *)from)->sin_addr.s_addr) &&
-		    (p->icp.port == ntohs(((struct sockaddr_in *)from)->sin_port)))
-		    return p;
-		break;
+	    if (ip.s_addr == p->addresses[j].s_addr && port == p->icp.port) {
+		return p;
 	    }
 	}
     }
@@ -365,15 +352,15 @@
 void
 neighbors_init(void)
 {
-    struct sockaddr_storage name;
-    socklen_t len = sizeof(struct sockaddr_storage);
+    struct sockaddr_in name;
+    socklen_t len = sizeof(struct sockaddr_in);
     struct servent *sep = NULL;
     const char *me = getMyHostname();
     peer *this;
     peer *next;
     int fd = theInIcpConnection;
     if (fd >= 0) {
-	memset(&name, '\0', sizeof(struct sockaddr_storage));
+	memset(&name, '\0', sizeof(struct sockaddr_in));
 	if (getsockname(fd, (struct sockaddr *) &name, &len) < 0)
 	    debug(15, 1) ("getsockname(%d,%p,%p) failed.\n", fd, &name, &len);
 	for (this = Config.peers; this; this = next) {
@@ -382,9 +369,7 @@
 	    if (0 != strcmp(this->host, me))
 		continue;
 	    for (s = Config.Sockaddr.http; s; s = s->next) {
-		if (this->http_port != ((s->s.ss_family == AF_INET6) ? 
-			ntohs(((struct sockaddr_in6 *)&s->s)->sin6_port) :
-			ntohs(((struct sockaddr_in *)&s->s)->sin_port)) )
+		if (this->http_port != ntohs(s->s.sin_port))
 		    continue;
 		debug(15, 1) ("WARNING: Peer looks like this host\n");
 		debug(15, 1) ("         Ignoring %s %s/%d/%d\n",
@@ -402,7 +387,7 @@
 	echo_hdr.reqnum = 0;
 	echo_hdr.flags = 0;
 	echo_hdr.pad = 0;
-	xmemcpy(&echo_hdr.shostid, &name, len);
+	echo_hdr.shostid = name.sin_addr.s_addr;
 	sep = getservbyname("echo", "udp");
 	echo_port = sep ? ntohs((u_short) sep->s_port) : 7;
     }
@@ -471,36 +456,22 @@
 	    debug(15, 4) ("neighborsUdpPing: Looks like a dumb cache, send DECHO ping\n");
 	    echo_hdr.reqnum = reqnum;
 	    query = icpCreateMessage(ICP_DECHO, 0, url, reqnum, 0);
-	    if (p->in_addr.ss_family == AF_INET6)
-		icpUdpSend(theOutIcpConnection6,
-		    &p->in_addr,
-		    query,
-		    LOG_ICP_QUERY,
-		    0);
-	    else
-		icpUdpSend(theOutIcpConnection,
-		    &p->in_addr,
-		    query,
-		    LOG_ICP_QUERY,
-		    0);
+	    icpUdpSend(theOutIcpConnection,
+		&p->in_addr,
+		query,
+		LOG_ICP_QUERY,
+		0);
 	} else {
 	    flags = 0;
 	    if (Config.onoff.query_icmp)
 		if (p->icp.version == ICP_VERSION_2)
 		    flags |= ICP_FLAG_SRC_RTT;
 	    query = icpCreateMessage(ICP_QUERY, flags, url, reqnum, 0);
-	    if (p->in_addr.ss_family == AF_INET6)
-		icpUdpSend(theOutIcpConnection6,
-		    &p->in_addr,
-		    query,
-		    LOG_ICP_QUERY,
-		    0);
-	    else
-		icpUdpSend(theOutIcpConnection,
-		    &p->in_addr,
-		    query,
-		    LOG_ICP_QUERY,
-		    0);
+	    icpUdpSend(theOutIcpConnection,
+		&p->in_addr,
+		query,
+		LOG_ICP_QUERY,
+		0);
 	}
 	queries_sent++;
 
@@ -756,31 +727,23 @@
 static peer *non_peers = NULL;
 
 static void
-neighborIgnoreNonPeer(const struct sockaddr *from, icp_opcode opcode)
+neighborIgnoreNonPeer(const struct sockaddr_in *from, icp_opcode opcode)
 {
     peer *np;
     for (np = non_peers; np; np = np->next) {
-	if (from->sa_family !=  np->in_addr.ss_family)
+	if (np->in_addr.sin_addr.s_addr != from->sin_addr.s_addr)
 	    continue;
-	if ((from->sa_family == AF_INET6) &&
-	    IN6_ARE_ADDR_EQUAL(&((struct sockaddr_in6 *)&np->in_addr)->sin6_addr, &((struct sockaddr_in6 *)from)->sin6_addr) &&
-	    (((struct sockaddr_in6 *)&np->in_addr)->sin6_port == ntohs(((struct sockaddr_in6 *)from)->sin6_port)))
-	    continue;
-	else
-	if ((from->sa_family == AF_INET) &&
-	    (((struct sockaddr_in *)&np->in_addr)->sin_addr.s_addr == ((struct sockaddr_in *)from)->sin_addr.s_addr) &&
-	    (((struct sockaddr_in *)&np->in_addr)->sin_port == ntohs(((struct sockaddr_in *)from)->sin_port)))
+	if (np->in_addr.sin_port != from->sin_port)
 	    continue;
 	break;
     }
     if (np == NULL) {
 	np = xcalloc(1, sizeof(peer));
-	xmemcpy(&np->in_addr, &from, sizeof(struct sockaddr_storage));
-	np->icp.port = ntohs( (from->sa_family == AF_INET6) ?
-		((struct sockaddr_in6 *)from)->sin6_port :
-		((struct sockaddr_in *)from)->sin_port );
+	np->in_addr.sin_addr = from->sin_addr;
+	np->in_addr.sin_port = from->sin_port;
+	np->icp.port = ntohl(from->sin_port);
 	np->type = PEER_NONE;
-	np->host = xstrdup(sockaddr_ntoa(from));
+	np->host = xstrdup(inet_ntoa(from->sin_addr));
 	np->next = non_peers;
 	non_peers = np;
     }
@@ -815,7 +778,7 @@
  * If a hit process is already started, then sobeit
  */
 void
-neighborsUdpAck(const cache_key * key, icp_common_t * header, const struct sockaddr *from)
+neighborsUdpAck(const cache_key * key, icp_common_t * header, const struct sockaddr_in *from)
 {
     peer *p = NULL;
     StoreEntry *entry;
@@ -905,7 +868,7 @@
 	    mem->ping_reply_callback(NULL, ntype, PROTO_ICP, header, mem->ircb_data);
 #endif
 	} else {
-	    debug(15, 1) ("Unsolicited SECHO from %s\n", sockaddr_ntoa(from));
+	    debug(15, 1) ("Unsolicited SECHO from %s\n", inet_ntoa(from->sin_addr));
 	}
     } else if (opcode == ICP_DENIED) {
 	if (p == NULL) {
@@ -1019,7 +982,7 @@
 peerDNSConfigure(const ipcache_addrs * ia, void *data)
 {
     peer *p = data;
-    struct sockaddr_storage *ap;
+    struct sockaddr_in *ap;
     int j;
     if (p->n_addresses == 0) {
 	debug(15, 1) ("Configuring %s %s/%d/%d\n", neighborTypeStr(p),
@@ -1038,17 +1001,15 @@
     }
     p->tcp_up = PEER_TCP_MAGIC_COUNT;
     for (j = 0; j < (int) ia->count && j < PEER_MAX_ADDRESSES; j++) {
-	xmemcpy(&p->addresses[j], &ia->in_addrs[j], sizeof(struct sockaddr_storage));
-	debug(15, 2) ("--> IP address #%d: %s\n", j, sockaddr_ntoa(&p->addresses[j]));
+	p->addresses[j] = ia->in_addrs[j];
+	debug(15, 2) ("--> IP address #%d: %s\n", j, inet_ntoa(p->addresses[j]));
 	p->n_addresses++;
     }
-    ap = (struct sockaddr_storage *)&p->in_addr;
-    memset(ap, '\0', sizeof(struct sockaddr_storage));
-    xmemcpy(ap, &p->addresses[0], sizeof(struct sockaddr_storage));
-    if (ap->ss_family == AF_INET6)
-	((struct sockaddr_in6 *)ap)->sin6_port = htons(p->icp.port);
-    else
-	((struct sockaddr_in *)ap)->sin_port = htons(p->icp.port);
+    ap = &p->in_addr;
+    memset(ap, '\0', sizeof(struct sockaddr_in));
+    ap->sin_family = AF_INET;
+    ap->sin_addr = p->addresses[0];
+    ap->sin_port = htons(p->icp.port);
     if (p->type == PEER_MULTICAST)
 	peerCountMcastPeersSchedule(p, 10);
     if (p->type != PEER_MULTICAST)
@@ -1128,7 +1089,6 @@
 peerProbeConnect(peer * p)
 {
     int fd;
-    struct sockaddr_storage outsock;
     time_t ctimeout = p->connect_timeout > 0 ? p->connect_timeout
     : Config.Timeout.peer_connect;
     int ret = squid_curtime - p->stats.last_connect_failure > ctimeout * 10;
@@ -1136,18 +1096,16 @@
 	return ret;		/* probe already running */
     if (squid_curtime - p->stats.last_connect_probe == 0)
 	return ret;		/* don't probe to often */
-    memset(&outsock, '\0', sizeof(outsock));
-    outsock.ss_family = p->in_addr.ss_family;
-    fd = comm_open(SOCK_STREAM, IPPROTO_TCP, &outsock,
-	COMM_NONBLOCKING, p->host);
+    fd = comm_open(SOCK_STREAM, IPPROTO_TCP, getOutgoingAddr(NULL),
+	0, COMM_NONBLOCKING, p->host);
     if (fd < 0)
 	return ret;
     commSetTimeout(fd, ctimeout, peerProbeConnectTimeout, p);
     p->test_fd = fd;
     p->stats.last_connect_probe = squid_curtime;
-    p->ia_cur = -1;
     commConnectStart(p->test_fd,
-	p->host, p->http_port,
+	p->host,
+	p->http_port,
 	peerProbeConnectDone,
 	p,
 	NULL);
@@ -1192,7 +1150,7 @@
     LOCAL_ARRAY(char, url, MAX_URL);
     assert(p->type == PEER_MULTICAST);
     p->mcast.flags.count_event_pending = 0;
-    snprintf(url, MAX_URL, "http://%s/", sockaddr_ntoa(&p->in_addr));
+    snprintf(url, MAX_URL, "http://%s/", inet_ntoa(p->in_addr.sin_addr));
     fake = storeCreateEntry(url, null_request_flags, METHOD_GET);
     psstate = cbdataAlloc(ps_state);
     psstate->request = requestLink(urlParse(METHOD_GET, url));
@@ -1364,7 +1322,7 @@
 	dump_peer_options(sentry, e);
 	for (i = 0; i < e->n_addresses; i++) {
 	    storeAppendPrintf(sentry, "Address[%d] : %s\n", i,
-		sockaddr_ntoa(&e->addresses[i]));
+		inet_ntoa(e->addresses[i]));
 	}
 	storeAppendPrintf(sentry, "Status     : %s\n",
 	    neighborUp(e) ? "Up" : "Down");
@@ -1432,7 +1390,7 @@
 
 #if USE_HTCP
 void
-neighborsHtcpReply(const cache_key * key, htcpReplyData * htcp, const struct sockaddr *from)
+neighborsHtcpReply(const cache_key * key, htcpReplyData * htcp, const struct sockaddr_in *from)
 {
     StoreEntry *e = storeGet(key);
     MemObject *mem = NULL;
Index: squid/src/net_db.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/net_db.c,v
retrieving revision 1.6.2.7
retrieving revision 1.6.2.8
diff -u -r1.6.2.7 -r1.6.2.8
--- squid/src/net_db.c	1 Jul 2007 05:44:24 -0000	1.6.2.7
+++ squid/src/net_db.c	2 Jul 2007 07:37:01 -0000	1.6.2.8
@@ -1,6 +1,6 @@
 
 /*
- * $Id: net_db.c,v 1.6.2.7 2007/07/01 05:44:24 amosjeffries Exp $
+ * $Id: net_db.c,v 1.6.2.8 2007/07/02 07:37:01 amosjeffries Exp $
  *
  * DEBUG: section 38    Network Measurement Database
  * AUTHOR: Duane Wessels
@@ -700,7 +700,7 @@
 }
 
 void
-netdbHandlePingReply(const struct sockaddr *from, int hops, int rtt)
+netdbHandlePingReply(const struct sockaddr_in *from, int hops, int rtt)
 {
 #if USE_ICMP
     netdbEntry *n;
@@ -738,7 +738,7 @@
 }
 
 int
-netdbHops(struct sockaddr *addr)
+netdbHops(struct in_addr addr)
 {
 #if USE_ICMP
     netdbEntry *n = netdbLookupAddr(addr);
@@ -898,7 +898,7 @@
 }
 
 void
-netdbDeleteAddrNetwork(struct sockaddr *addr)
+netdbDeleteAddrNetwork(struct in_addr addr)
 {
 #if USE_ICMP
     netdbEntry *n = netdbLookupAddr(addr);
Index: squid/src/pconn.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/pconn.c,v
retrieving revision 1.4.6.5
retrieving revision 1.4.6.6
diff -u -r1.4.6.5 -r1.4.6.6
--- squid/src/pconn.c	1 Jul 2007 05:44:24 -0000	1.4.6.5
+++ squid/src/pconn.c	2 Jul 2007 07:37:01 -0000	1.4.6.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: pconn.c,v 1.4.6.5 2007/07/01 05:44:24 amosjeffries Exp $
+ * $Id: pconn.c,v 1.4.6.6 2007/07/02 07:37:01 amosjeffries Exp $
  *
  * DEBUG: section 48    Persistent Connections
  * AUTHOR: Duane Wessels
@@ -49,7 +49,7 @@
 
 static PF pconnRead;
 static PF pconnTimeout;
-static int pconnKey(char *buf, const char *host, u_short port, const char *domain, struct sockaddr *client_address);
+static int pconnKey(char *buf, const char *host, u_short port, const char *domain, struct in_addr *client_address, u_short client_port);
 static hash_table *table = NULL;
 static struct _pconn *pconnNew(const char *key);
 static void pconnDelete(struct _pconn *p);
@@ -62,16 +62,16 @@
 
 static int
 pconnKey(char *buf, const char *host, u_short port, const char *domain,
-    struct sockaddr *client_address)
+    struct in_addr *client_address, u_short client_port)
 {
     if (domain && client_address)
-	return snprintf(buf, PCONN_KEYLEN, "%s.%d:%s./%s", host, (int) port,
-	    sockaddr_ntoa(client_address), domain);
+	return snprintf(buf, PCONN_KEYLEN, "%s.%d:%s.%d/%s", host, (int) port,
+	    inet_ntoa(*client_address), (int) client_port, domain);
     else if (domain && (!client_address))
 	return snprintf(buf, PCONN_KEYLEN, "%s.%d/%s", host, (int) port, domain);
     else if ((!domain) && client_address)
-	return snprintf(buf, PCONN_KEYLEN, "%s.%d:%s.", host, (int) port,
-	    sockaddr_ntoa(client_address));
+	return snprintf(buf, PCONN_KEYLEN, "%s.%d:%s.%d", host, (int) port,
+	    inet_ntoa(*client_address), (int) client_port);
     else
 	return snprintf(buf, PCONN_KEYLEN, "%s:%d", host, (int) port);
 }
@@ -194,7 +194,7 @@
 }
 
 void
-pconnPush(int fd, const char *host, u_short port, const char *domain, struct sockaddr *client_address)
+pconnPush(int fd, const char *host, u_short port, const char *domain, struct in_addr *client_address, u_short client_port)
 {
     struct _pconn *p;
     int *old;
@@ -209,7 +209,7 @@
 	return;
     }
     assert(table != NULL);
-    pconnKey(key, host, port, domain, client_address);
+    pconnKey(key, host, port, domain, client_address, client_port);
     p = (struct _pconn *) hash_lookup(table, key);
     if (p == NULL)
 	p = pconnNew(key);
@@ -233,13 +233,13 @@
 }
 
 int
-pconnPop(const char *host, u_short port, const char *domain, struct sockaddr *client_address)
+pconnPop(const char *host, u_short port, const char *domain, struct in_addr *client_address, u_short client_port)
 {
     struct _pconn *p;
     hash_link *hptr;
     int fd = -1;
     assert(table != NULL);
-    hptr = pconnLookup(host, port, domain, client_address);
+    hptr = pconnLookup(host, port, domain, client_address, client_port);
     if (hptr != NULL) {
 	p = (struct _pconn *) hptr;
 	assert(p->nfds > 0);
@@ -252,11 +252,11 @@
 }
 
 hash_link *
-pconnLookup(const char *peer, u_short port, const char *domain, struct sockaddr *client_address)
+pconnLookup(const char *peer, u_short port, const char *domain, struct in_addr * client_address, u_short client_port)
 {
     LOCAL_ARRAY(char, key, PCONN_KEYLEN);
     assert(table != NULL);
-    pconnKey(key, peer, port, domain, client_address);
+    pconnKey(key, peer, port, domain, client_address, client_port);
     return hash_lookup(table, key);
 }
 
